let bucket m n a b = 
  let cumulative = ref Log_float.zero in
  for j = b to a+b do
    if j <= n 
    then
      cumulative := Log_float.add !cumulative 
	  (Choose.approx_log_choose n j +. 
	     Choose.approx_log_choose m (a+b-j))
   done;
  cumulative := !cumulative -. (Choose.approx_log_choose (n+m) (a+b));
  !cumulative

let upper_bound m n a log_delta =
  Search.monotone_decreasing_int (bucket m n a) log_delta 0 n
