let near epsilon v1 v2 =
   v1 > v2 -. epsilon && v2 > v1 -. epsilon

let less epsilon v1 v2 =
  v1 < v2 or near epsilon v1 v2

let round f = 
  let (fract,integral) = modf f
  in if integral > float max_int then max_int
  else if integral < float min_int then min_int
  else if (fract > 0.5) then (truncate f) +1
      else truncate f
